# Class `wibox.layout.align`

### Usage:

    wibox.widget {
        generic_widget( 'first'  ),
        generic_widget( 'second' ),
        generic_widget( 'third'  ),
        layout  = wibox.layout.align.horizontal
    }

### Info:

- Copyright: 2010 Uli Schlachter
- Author: Uli Schlachter

## Object properties

first | Set the layout's first widget.
second | Set the layout's second widget.
third | Set the layout's third widget.
children | All direct children of this layout.
expand | Set the expand mode which determines how sub widgets expand to take up unused space.
children | Get all direct children of this layout.
forced_height | Force a widget height.
forced_width | Force a widget width.
opacity | The widget opacity (transparency).
visible | The widget visibility.

## Signals

widget::layout_changed | When the layout (size) change.
widget::redraw_needed | When the widget content changed.
button::press | When a mouse button is pressed over the widget.
button::release | When a mouse button is released over the widget.
mouse::enter | When the mouse enter a widget.
mouse::leave | When the mouse leave a widget.

## Methods

wibox.layout.align:horizontal ([left[, middle[, right]]]) | Returns a new horizontal align layout.
wibox.layout.align:vertical ([top[, middle[, bottom]]]) | Returns a new vertical align layout.
wibox.layout.align:set (index, widget2) | Set a widget at a specific index, replace the current one.
wibox.layout.align:replace_widget (widget, widget2[, recursive=false]) | Replace the first instance of widget in the layout with `widget2`.
wibox.layout.align:swap (index1, index2) | Swap 2 widgets in a layout.
wibox.layout.align:swap_widgets (widget1, widget2[, recursive=false]) | Swap 2 widgets in a layout.
wibox.layout.align:reset (layout) | Reset a ratio layout.
wibox.layout.align:get_all_children () | Get all direct and indirect children widgets.
wibox.layout.align:setup (args) | Set a declarative widget hierarchy description.
wibox.layout.align:buttons (_buttons) | Set/get a widget's buttons.
wibox.layout.align:emit_signal_recursive (signal_name, ...) | Emit a signal and ensure all parent widgets in the hierarchies also forward the signal.
wibox.layout.align:emit_signal (name, ...) | Emit a signal.
wibox.layout.align:connect_signal (name, func) | Connect to a signal.
wibox.layout.align:weak_connect_signal (name, func) | Connect to a signal weakly.

## Object properties

first
  Set the layout's first widget. This is the widget that is at the left/top
second
  Set the layout's second widget. This is the centered one.
third
  Set the layout's third widget. This is the widget that is at the right/bottom
children
  All direct children of this layout. This can be used to replace all 3 widgets at once.
expand
  Set the expand mode which determines how sub widgets expand to take up unused space.

  ### Type:

  - mode string

    How to use unused space.

    - "inside" - Default option. Size of outside widgets is determined using their fit function. Second, middle, or center widget expands to fill remaining space.
    - "outside" - Center widget is sized using its fit function and placed in the center of the allowed space. Outside widgets expand (or contract) to fill remaining space on their side.
    - "none" - All widgets are sized using their fit function, drawn to only the returned space, or remaining space, whichever is smaller. Center widget gets priority.
    (default inside)
children
  Get all direct children of this layout.

  ### Type:

  - layout The layout you are modifying.
forced_height
  Force a widget height.

  ### Type:

  - height number or nil The height (`nil` for automatic)
forced_width
  Force a widget width.

  ### Type:

  - width number or nil The width (`nil` for automatic)
opacity
  The widget opacity (transparency).

  ### Type:

  - opacity number The opacity (between 0 and 1) (default 1)
visible
  The widget visibility.

  ### Type:

  - boolean

## Signals

widget::layout_changed
  When the layout (size) change. This signal is emitted when the previous results of `:layout()` and `:fit()` are no longer valid. Unless this signal is emitted, `:layout()` and `:fit()` must return the same result when called with the same arguments.

  ### See also:

  widget::redraw_needed
widget::redraw_needed
  When the widget content changed. This signal is emitted when the content of the widget changes. The widget will be redrawn, it is not re-layouted. Put differently, it is assumed that `:layout()` and `:fit()` would still return the same results as before.

  ### See also:

  widget::layout_changed
button::press
  When a mouse button is pressed over the widget.

  ### Arguments:

  - lx number The horizontal position relative to the (0,0) position in the widget.
  - ly number The vertical position relative to the (0,0) position in the widget.
  - button number The button number.
  - mods table The modifiers (mod4, mod1 (alt), Control, Shift)
  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse
button::release
  When a mouse button is released over the widget.

  ### Arguments:

  - lx number The horizontal position relative to the (0,0) position in the widget.
  - ly number The vertical position relative to the (0,0) position in the widget.
  - button number The button number.
  - mods table The modifiers (mod4, mod1 (alt), Control, Shift)
  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse
mouse::enter
  When the mouse enter a widget.

  ### Arguments:

  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse
mouse::leave
  When the mouse leave a widget.

  ### Arguments:

  - find_widgets_result The entry from the result of wibox.drawable:find_widgets for the position that the mouse hit.
    - drawable wibox.drawable The drawable containing the widget.
    - widget widget The widget being displayed.
    - hierarchy wibox.hierarchy The hierarchy managing the widget's geometry.
    - x number An approximation of the X position that the widget is visible at on the surface.
    - y number An approximation of the Y position that the widget is visible at on the surface.
    - width number An approximation of the width that the widget is visible at on the surface.
    - height number An approximation of the height that the widget is visible at on the surface.
    - widget_width number The exact width of the widget in its local coordinate system.
    - widget_height number The exact height of the widget in its local coordinate system.

  ### See also:

  mouse

## Methods

wibox.layout.align:horizontal ([left[, middle[, right]]])
  Returns a new horizontal align layout. An align layout can display up to three widgets. The widget set via :setleft() is left-aligned. :setright() sets a widget which will be right-aligned. The remaining space between those two will be given to the widget set via :set_middle().
  - left widget Widget to be put to the left. (optional)
  - middle widget Widget to be put to the middle. (optional)
  - right widget Widget to be put to the right. (optional)
wibox.layout.align:vertical ([top[, middle[, bottom]]])
  Returns a new vertical align layout. An align layout can display up to three widgets. The widget set via :settop() is top-aligned. :setbottom() sets a widget which will be bottom-aligned. The remaining space between those two will be given to the widget set via :set_middle().
  - top widget Widget to be put to the top. (optional)
  - middle widget Widget to be put to the middle. (optional)
  - bottom widget Widget to be put to the right. (optional)
wibox.layout.align:set (index, widget2)
  Set a widget at a specific index, replace the current one. Signal: widget::replaced The argument is the new widget and the old one and the index.
  - index number A widget or a widget index
  - widget2 The widget to take the place of the first one

  ### Returns:

  boolean If the operation is successful
wibox.layout.align:replace_widget (widget, widget2[, recursive=false])
  Replace the first instance of widget in the layout with `widget2`. Signal: widget::replaced The argument is the new widget and the old one and the index.
  - widget The widget to replace
  - widget2 The widget to replace widget with
  - recursive boolean Dig in all compatible layouts to find the widget. (default false)

  ### Returns:

  boolean If the operation is successful
wibox.layout.align:swap (index1, index2)
  Swap 2 widgets in a layout. Signal: widget::swapped The arguments are both widgets and both (new) indexes.
  - index1 number The first widget index
  - index2 number The second widget index

  ### Returns:

  boolean If the operation is successful
wibox.layout.align:swap_widgets (widget1, widget2[, recursive=false])
  Swap 2 widgets in a layout. If widget1 is present multiple time, only the first instance is swapped Signal: widget::swapped The arguments are both widgets and both (new) indexes. if the layouts not the same, then only `widget::replaced` will be emitted.
  - widget1 The first widget
  - widget2 The second widget
  - recursive boolean Dig in all compatible layouts to find the widget. (default false)

  ### Returns:

  boolean If the operation is successful
wibox.layout.align:reset (layout)
  Reset a ratio layout. This removes all widgets from the layout. Signal: widget::reset
  - layout The layout you are modifying.
wibox.layout.align:get_all_children ()
  Get all direct and indirect children widgets. This will scan all containers recursively to find widgets Warning: This method it prone to stack overflow id the widget, or any of its children, contain (directly or indirectly) itself.

  ### Returns:

  table The children
wibox.layout.align:setup (args)
  Set a declarative widget hierarchy description. See The declarative layout system
  - args An array containing the widgets disposition
wibox.layout.align:buttons (_buttons)
  Set/get a widget's buttons.
  - _buttons The table of buttons that should bind to the widget.
wibox.layout.align:emit_signal_recursive (signal_name, ...)
  Emit a signal and ensure all parent widgets in the hierarchies also forward the signal. This is useful to track signals when there is a dynamic set of containers and layouts wrapping the widget.
  - signal_name string
  - ... Other arguments
wibox.layout.align:emit_signal (name, ...)
  Emit a signal.
  - name string The name of the signal.
  - ... Extra arguments for the callback functions. Each connected function receives the object as first argument and then any extra arguments that are given to emit_signal().
wibox.layout.align:connect_signal (name, func)
  Connect to a signal.
  - name string The name of the signal.
  - func function The callback to call when the signal is emitted.
wibox.layout.align:weak_connect_signal (name, func)
  Connect to a signal weakly.

  This allows the callback function to be garbage collected and automatically disconnects the signal when that happens.

  Warning: Only use this function if you really, really, really know what you are doing.

  - name string The name of the signal.
  - func function The callback to call when the signal is emitted.

generated by LDoc 1.5.0 Last updated 2025-09-26 21:04:17